;;;  Hammer.lsp
;;; ------------------------
;;;
;;; Hammer is a AutoCAD module to make a drawing flath !
;;; It is usefull to drawings which have been influented
;;; by the problem in AutoCAD which results in that
;;; 2D drawings will be placed in different layers, and
;;; measuring will be wrong.
;;;
;;;  Copyright 1997 by Martin Djerns
;;; - Version 0.1                  ( < 1.0 = still in an internal version)
;;; - No internal test
;;; - No field test
;;; - release 140297
;;; ---------------------------------------------------------------------

; Sets a Z value to a Vertex element
( Defun SetZ (AEntityName ZValue)
  ( SetQ AEntity (entGet AEntityName)
         APoint  (Assoc 10 AEntity)
         XValue  (cadr  APoint)
         YValue  (caddr APoint)
         AEntity (Subst (cons 10 (list XValue YValue ZValue))
                         APoint
                         AEntity)
         APoint  (Assoc 11 AEntity)
         XValue  (cadr  APoint)
         YValue  (caddr APoint)
         AEntity (Subst (cons 11 (list XValue YValue ZValue))
                         APoint
                         AEntity)
  )
  ( entMod AEntity)
)

( Defun c:Hammer ()
  ; Introduction to the program
  ( Write-Line "Hammer v. 0.1 -  Copyright Martin Djerns 1997 - r140297")

  ; Create a list of the interresting elements
  ( Princ "\nSelecting elements...")
  ( SetQ PolyLineList (ssGet "X" '((-4 . "<OR")
                                     (0 . "POLYLINE")
                                     (0 . "LINE")
                                     (0 . "CIRCLE")
                                    (-4 . "OR>")))
         OldEntityName NIL)
  ( Princ " OK\nMoving elements")
  ( If ( SetQ AEntityName (entNext))
    ( Progn
      ( SetZ AEntityName 0.0)
      ( SetQ OldEntityName AEntityName)

      ( While ( SetQ AEntityName (entNext OldEntityName))
        ( Progn
          ( Princ ".")
          ( SetZ AEntityName 0.0)
          ( SetQ OldEntityName AEntityName)
        ) 
      )

    )
  )

  ( Princ "\n")
  ( Command "Regen")

  ; Outtro for the program
  ( Write-Line "\nHammer v. 0.1 -  Copyright Martin Djerns 1997 - r140297")
  ( Princ)
)


